/*******************************************************************************
 * Copyright (c) 2013, Perforce Software
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************/
package com.perforce.p4java.extension.server;

import com.perforce.p4java.server.IServerAddress;

/**
 * 
 */
public interface ServerLocation {
    enum P4DProtocol {
	NONE, SSL;

	public String toString() {
	    switch (this) {
	    case NONE:
		return IServerAddress.Protocol.P4JRPCNTS.toString();
	    case SSL:
		return IServerAddress.Protocol.P4JRPCNTSSSL.toString();
	    default:
		return IServerAddress.Protocol.P4JRPCNTS.toString();
	    }
	}

	public static P4DProtocol fromString(String protocol) {
	    if (protocol != null) {
		for (P4DProtocol p : P4DProtocol.values()) {
		    if (p.name().equalsIgnoreCase(protocol)) {
			return p;
		    }
		}
	    }
	    return null;
	}

    }

    P4DProtocol getProtocol();

    String getHost();

    int getPort();

    String getCharset();
}
